# coding: utf-8

"""
    VeeRoute.LSS Delivery

    VeeRoute.LSS Delivery API  # noqa: E501

    The version of the OpenAPI document: 3.4.161326
    Contact: support@veeroute.com
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from vrt_lss_delivery.configuration import Configuration


class PlanTask(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'warehouses': 'list[Warehouse]',
        'orders': 'list[Order]',
        'performers': 'list[Performer]',
        'trips': 'list[Trip]',
        'settings': 'PlanSettings',
        'delivery_settings': 'DeliverySettings'
    }

    attribute_map = {
        'warehouses': 'warehouses',
        'orders': 'orders',
        'performers': 'performers',
        'trips': 'trips',
        'settings': 'settings',
        'delivery_settings': 'delivery_settings'
    }

    def __init__(self, warehouses=None, orders=None, performers=None, trips=None, settings=None, delivery_settings=None, local_vars_configuration=None):  # noqa: E501
        """PlanTask - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._warehouses = None
        self._orders = None
        self._performers = None
        self._trips = None
        self._settings = None
        self._delivery_settings = None
        self.discriminator = None

        self.warehouses = warehouses
        self.orders = orders
        self.performers = performers
        if trips is not None:
            self.trips = trips
        if settings is not None:
            self.settings = settings
        if delivery_settings is not None:
            self.delivery_settings = delivery_settings

    @property
    def warehouses(self):
        """Gets the warehouses of this PlanTask.  # noqa: E501

        List of warehouses for cargo pickup or drop.  # noqa: E501

        :return: The warehouses of this PlanTask.  # noqa: E501
        :rtype: list[Warehouse]
        """
        return self._warehouses

    @warehouses.setter
    def warehouses(self, warehouses):
        """Sets the warehouses of this PlanTask.

        List of warehouses for cargo pickup or drop.  # noqa: E501

        :param warehouses: The warehouses of this PlanTask.  # noqa: E501
        :type: list[Warehouse]
        """
        if self.local_vars_configuration.client_side_validation and warehouses is None:  # noqa: E501
            raise ValueError("Invalid value for `warehouses`, must not be `None`")  # noqa: E501

        self._warehouses = warehouses

    @property
    def orders(self):
        """Gets the orders of this PlanTask.  # noqa: E501

        Orders list.  # noqa: E501

        :return: The orders of this PlanTask.  # noqa: E501
        :rtype: list[Order]
        """
        return self._orders

    @orders.setter
    def orders(self, orders):
        """Sets the orders of this PlanTask.

        Orders list.  # noqa: E501

        :param orders: The orders of this PlanTask.  # noqa: E501
        :type: list[Order]
        """
        if self.local_vars_configuration.client_side_validation and orders is None:  # noqa: E501
            raise ValueError("Invalid value for `orders`, must not be `None`")  # noqa: E501

        self._orders = orders

    @property
    def performers(self):
        """Gets the performers of this PlanTask.  # noqa: E501

        List of performers, with their working schedule and vehicle characteristics.  # noqa: E501

        :return: The performers of this PlanTask.  # noqa: E501
        :rtype: list[Performer]
        """
        return self._performers

    @performers.setter
    def performers(self, performers):
        """Sets the performers of this PlanTask.

        List of performers, with their working schedule and vehicle characteristics.  # noqa: E501

        :param performers: The performers of this PlanTask.  # noqa: E501
        :type: list[Performer]
        """
        if self.local_vars_configuration.client_side_validation and performers is None:  # noqa: E501
            raise ValueError("Invalid value for `performers`, must not be `None`")  # noqa: E501

        self._performers = performers

    @property
    def trips(self):
        """Gets the trips of this PlanTask.  # noqa: E501

        Existing routes that need to be replanned.  # noqa: E501

        :return: The trips of this PlanTask.  # noqa: E501
        :rtype: list[Trip]
        """
        return self._trips

    @trips.setter
    def trips(self, trips):
        """Sets the trips of this PlanTask.

        Existing routes that need to be replanned.  # noqa: E501

        :param trips: The trips of this PlanTask.  # noqa: E501
        :type: list[Trip]
        """

        self._trips = trips

    @property
    def settings(self):
        """Gets the settings of this PlanTask.  # noqa: E501


        :return: The settings of this PlanTask.  # noqa: E501
        :rtype: PlanSettings
        """
        return self._settings

    @settings.setter
    def settings(self, settings):
        """Sets the settings of this PlanTask.


        :param settings: The settings of this PlanTask.  # noqa: E501
        :type: PlanSettings
        """

        self._settings = settings

    @property
    def delivery_settings(self):
        """Gets the delivery_settings of this PlanTask.  # noqa: E501


        :return: The delivery_settings of this PlanTask.  # noqa: E501
        :rtype: DeliverySettings
        """
        return self._delivery_settings

    @delivery_settings.setter
    def delivery_settings(self, delivery_settings):
        """Sets the delivery_settings of this PlanTask.


        :param delivery_settings: The delivery_settings of this PlanTask.  # noqa: E501
        :type: DeliverySettings
        """

        self._delivery_settings = delivery_settings

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PlanTask):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, PlanTask):
            return True

        return self.to_dict() != other.to_dict()
